namespace Polly8Study.Test
{
    /// <summary>
    /// Polly8ʱ 
    /// ؼ
    ///     CancellationTokenûǲʹõ
    ///     ֮ǰ汾еֹ۳ʱ۳ʱòȡ
    /// </summary>
    public class Polly8TimeoutStrategyTest
    {
        private readonly ITestOutputHelper _output;

        public Polly8TimeoutStrategyTest(ITestOutputHelper testOutput)
        {
            _output = testOutput;
        }

        /// <summary>
        /// ʱѡ
        /// </summary>
        [Fact]
        public void TimeoutStrategyOptions_Test()
        {
            //ֱ
            new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromMilliseconds(100))
                .Build();

            //Ĭֵ
            var defaultOption = new TimeoutStrategyOptions();

            //ȫ
            TimeoutStrategyOptions timeoutOption = new TimeoutStrategyOptions
            {
                //ΨһʶضԵضʵҲɸԲɵң
                Name = "timeout",

                //̶ʱʱ(TimeoutGeneratorЧ)
                Timeout = TimeSpan.FromSeconds(2),

                //̬ʱʱ
                //TimeoutGenerator =  arg => 
                //{
                //    var ts = TimeSpan.FromSeconds(Math.Pow(2, 1));

                //    return ValueTask.FromResult(ts);
                //},

                //ʱʱĳʱί
                OnTimeout = (args) =>
                {
                    var key = args.Context.OperationKey;
                    _output.WriteLine("OnTimeout");
                    return ValueTask.CompletedTask;
                },
            };

            //ʹ
            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(timeoutOption)
                .Build();
        }

        /// <summary>
        /// ǿȡ񣺺Գʱ
        /// ִͬ
        /// </summary>
        [Fact]
        public void No_CancellationToken_Test()
        {
            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromSeconds(1))
                .Build();

            //ⲿtcsʡ
            var tcs = new CancellationTokenSource();
            try
            {
                pipeline.Execute
                (
                    //˴ǿȡ񣬷ʱΪ(һֱȴ)
                    callback: (CancellationToken innerToken) =>
                    {
                        //ȻӿںʱΪûʹáȡġ Send󣬳ʱñԣȴӿȷ
                        HttpRequestMessage requestMessage = new HttpRequestMessage(HttpMethod.Get, "http://localhost:44344/api/Timeout/Slow");

                        //ؼSend ûд cancellationToken
                        //ֻͬҪǿȡ
                        HttpResponseMessage response = new HttpClient().Send(requestMessage);
                        if (response.IsSuccessStatusCode == false)
                        {
                            _output.WriteLine($"Ӧ,Ӧ룺{response.StatusCode}");
                            return;
                        }
                        var stream = response.Content.ReadAsStream();
                        var bs = new byte[stream.Length];
                        stream.Read(bs, 0, (int)stream.Length);

                        var text = System.Text.UTF8Encoding.UTF8.GetString(bs);

                        _output.WriteLine($"Ӧ:{text}");

                        _output.WriteLine("ִ");
                    },
                    cancellationToken: tcs.Token
                );
            }
            catch (OperationCanceledException ex)
            {
                _output.WriteLine($"ȡ쳣:{ex.Message}");
            }
            catch (TimeoutRejectedException ex)
            {
                _output.WriteLine($"ʱ쳣:{ex.Message}");
            }
            catch (Exception ex)
            {
                _output.WriteLine($"API쳣{ex.Message}");
            }
            finally
            {
                tcs.TryReset();
            }
        }

        /// <summary>
        /// ȡ:ʱ
        /// ִͬ
        /// </summary>
        [Fact]
        public void Has_CancellationToken_Timeout_Test()
        {
            TimeoutStrategyOptions timeoutOption = new TimeoutStrategyOptions
            {
                //ΨһʶضԵضʵҲɸԲɵң
                Name = "timeout",

                //̶ʱʱ(TimeoutGeneratorЧ)
                Timeout = TimeSpan.FromSeconds(1),

                //̬ʱʱ
                //TimeoutGenerator =  arg => 
                //{
                //    var ts = TimeSpan.FromSeconds(Math.Pow(2, 1));

                //    return ValueTask.FromResult(ts);
                //},

                //ʱʱĳʱί
                OnTimeout = (args) =>
                {
                    _output.WriteLine("OnTimeout ʱίִ");
                    return ValueTask.CompletedTask;
                },
            };

            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(timeoutOption)
                .Build();

            var tcs = new CancellationTokenSource();
            try
            {
                pipeline.Execute
                (
                    //˴ǿȡ񣬷ʱΪ(һֱȴ)
                    callback: (innerToken) =>
                    {
                        HttpRequestMessage r = new HttpRequestMessage(HttpMethod.Get, "http://localhost:44344/api/Timeout/Slow");
                        var response = new HttpClient().Send(r, innerToken);
                        if (response.IsSuccessStatusCode == false)
                        {
                            Console.WriteLine("Ӧ");
                            return;
                        }
                        var stream = response.Content.ReadAsStream();
                        var bs = new byte[stream.Length];
                        stream.Read(bs, 0, (int)stream.Length);

                        var text = System.Text.UTF8Encoding.UTF8.GetString(bs);

                        _output.WriteLine($"Ӧ:{text}");
                        _output.WriteLine("ִ");
                    },
                    cancellationToken: tcs.Token
                );
            }
            catch (OperationCanceledException ex)
            {
                _output.WriteLine($"ȡ쳣:{ex.Message}");
            }
            catch (TimeoutRejectedException ex)
            {
                _output.WriteLine($"ʱ쳣:{ex.Message}");
            }
            catch (Exception ex)
            {
                _output.WriteLine($"API쳣{ex.Message}");
            }
            finally
            {
                tcs.TryReset();
            }
        }

        /// <summary>
        /// ȡ:ʱ
        /// ִͬ
        /// </summary>
        [Fact]
        public void Has_CancellationToken_NotTimeout_Test()
        {
            TimeoutStrategyOptions timeoutOption = new TimeoutStrategyOptions
            {
                //ΨһʶضԵضʵҲɸԲɵң
                Name = "timeout",

                //̶ʱʱ(TimeoutGeneratorЧ)
                Timeout = TimeSpan.FromSeconds(5),

                //̬ʱʱ
                //TimeoutGenerator =  arg => 
                //{
                //    var ts = TimeSpan.FromSeconds(Math.Pow(2, 1));

                //    return ValueTask.FromResult(ts);
                //},

                //ʱʱĳʱί
                OnTimeout = (args) =>
                {
                    Console.WriteLine("OnTimeout ʱίִ");
                    return ValueTask.CompletedTask;
                },
            };

            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(timeoutOption)
                .Build();

            var tcs = new CancellationTokenSource();
            try
            {
                pipeline.Execute
                (
                    //˴ǿȡ񣬷ʱΪ(һֱȴ)
                    callback: (innerToken) =>
                    {
                        HttpRequestMessage r = new HttpRequestMessage(HttpMethod.Get, "http://localhost:44344/api/Timeout/Slow");
                        var response = new HttpClient().Send(r, innerToken);
                        if (response.IsSuccessStatusCode == false)
                        {
                            Console.WriteLine("Ӧ");
                            return;
                        }
                        var stream = response.Content.ReadAsStream();
                        var bs = new byte[stream.Length];
                        stream.Read(bs, 0, (int)stream.Length);

                        var text = System.Text.UTF8Encoding.UTF8.GetString(bs);

                        _output.WriteLine($"Ӧ:{text}");
                        _output.WriteLine("ִ");
                    },
                    cancellationToken: tcs.Token
                );
            }
            catch (OperationCanceledException ex)
            {
                _output.WriteLine($"ȡ쳣:{ex.Message}");
            }
            catch (TimeoutRejectedException ex)
            {
                _output.WriteLine($"ʱ쳣:{ex.Message}");
            }
            catch (Exception ex)
            {
                _output.WriteLine($"API쳣{ex.Message}");
            }
            finally
            {
                tcs.TryReset();
            }

        }

        /// <summary>
        /// ȡ:Գʱ
        /// 첽ִ
        /// </summary>
        [Fact]
        public async void No_CancellationToken_ExecuteAsync_Test()
        {
            TimeoutStrategyOptions timeoutOption = new TimeoutStrategyOptions
            {
                //ΨһʶضԵضʵҲɸԲɵң
                Name = "timeout",

                //̶ʱʱ(TimeoutGeneratorЧ)
                Timeout = TimeSpan.FromSeconds(1),


                //ʱʱĳʱί
                OnTimeout = (args) =>
                {
                    _output.WriteLine("OnTimeout ʱίִ");
                    return ValueTask.CompletedTask;
                },
            };

            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(timeoutOption)
                .Build();

            var tcs = new CancellationTokenSource();
            try
            {
                await pipeline.ExecuteAsync
                (
                    //˴Ϊȡ񣬺Գʱ(һֱȴ)
                    callback: async (innerToken) =>
                    {
                        //ɴԼ2࣬ǳʱ1
                        await Task.Delay (1000*3);
                        _output.WriteLine("ִ");
                    },
                    cancellationToken: tcs.Token
                );
            }
            catch (OperationCanceledException ex)
            {
                _output.WriteLine($"ȡ쳣:{ex.Message}");
            }
            catch (TimeoutRejectedException ex)
            {
                _output.WriteLine($"ʱ쳣:{ex.Message}");
            }
            catch (Exception ex)
            {
                _output.WriteLine($"API쳣{ex.Message}");
            }
            finally
            {
                tcs.TryReset();
            }
        }

        /// <summary>
        /// ȡ:ʱ
        /// 첽ִ
        /// </summary>
        /// <returns></returns>
        [Fact]
        public async Task Has_CancellationToken_ExecuteAsync_Timeout_Test()
        {
            var pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromSeconds(1))
                .Build();

            await Assert.ThrowsAnyAsync<Exception>(async () => 
            {
                var cts = new CancellationTokenSource();
                await pipeline.ExecuteAsync
                (
                   callback: async (innerToken) =>
                    {
                        //ɴԼǳʱ1࣬3
                        await Task.Delay(1000 * 3, innerToken);
                        _output.WriteLine("ִ");
                    },
                    cancellationToken: cts.Token
                );
            });
        }

        /// <summary>
        /// ȡ:ʱ
        /// 첽ִ
        /// </summary>
        /// <returns></returns>
        [Fact]
        public async Task Has_CancellationToken_ExecuteAsync_NoTimeout_Test()
        {
            var pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromSeconds(3))
                .Build();

            try
            {
                var cts = new CancellationTokenSource();
                await pipeline.ExecuteAsync
                (
                   callback: async (innerToken) =>
                    {
                        //ʱɴԼʱ1
                        await Task.Delay(1000, innerToken);
                        _output.WriteLine("ִ");
                    },
                    cancellationToken: cts.Token
                );
            }
            catch (Exception ex)
            {
                _output.WriteLine(ex.Message);
            }
        }

        // <summary>
        /// ȡ:ʱ
        /// 첽ִУToken
        /// </summary>
        /// <returns></returns>
        [Fact]
        public async Task Has_OuterCancellationToken_ExecuteAsync_Timeout_Test()
        {
            var pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromSeconds(1))
                .Build();


            await Assert.ThrowsAnyAsync<Exception>(async () => 
            {
                await pipeline.ExecuteAsync
                (
                   callback: async (innerToken) =>
                   {
                       //ɴԼǳʱ1࣬3
                       await Task.Delay(1000 * 3, innerToken);
                       _output.WriteLine("ִ");
                   }
                );
            });
        }


        [Fact]
        public void SyncWithCancellationToken_Test()
        {
            ResiliencePipeline pipeline = new ResiliencePipelineBuilder()
                .AddTimeout(TimeSpan.FromSeconds(3))
                .Build();

            var tcs = new CancellationTokenSource();
            try
            {
                pipeline.Execute
                (
                    //˴ǿȡ񣬷ʱΪ(һֱȴ)
                    callback: SyncWithCancellationToken,
                    cancellationToken: tcs.Token
                );
            }
            catch (OperationCanceledException ex)
            {
                _output.WriteLine($"ȡ쳣:{ex.Message}");
            }
            catch (TimeoutRejectedException ex)
            {
                _output.WriteLine($"ʱ쳣:{ex.Message}");
            }
            catch (Exception ex)
            {
                _output.WriteLine($"API쳣{ex.Message}");
            }
            finally
            {
                tcs.TryReset();
            }
        }

        /// <summary>
        /// ʹCancellationTokenͬ
        /// </summary>
        private void SyncWithCancellationToken(CancellationToken cancellationToken)
        {
            Thread thread = new Thread((token) =>
            {
                int max = 500;
                while (max > 0)
                {
                    if (cancellationToken.IsCancellationRequested)
                    {
                        break;
                    }

                    max -= 1;
                    Thread.Sleep(10);
                }
            });

            thread.Start();
            thread.Join();
        }
    }
}